/* sorgente: CopiaIntBytexByte.c */

/*
** definizione e testing di diverse versioni di una funzione che copia
** una variabile intera sorgente su una variabile intera destinazione
** byte per byte
*/

/* inclusione dell'header file della libreria standard di
** definizioni di macro, costanti e dichiarazioni di funzioni e tipi
** per le varie operazioni di input/output */

#include <stdio.h>

/*
** prima definizione di una funzione che copia
** una variabile intera sorgente su una variabile intera
** destinazione byte per byte
*/
void CopiaIntBytePerByte_v1 ( int *sorg, int *dest)
  {
  /* definizione della variabile per la scansione
  ** delle locazioni assegnate alle variabili sorgente
  ** e destinazione */
  int cursore;
  
  /* assegna ad un puntatore a un carattere (minima unita' di
  ** informazione indirizzabile) l'indirizzo della prima locazione
  ** assegnata alla variabile destinazione */
  char * byte_dest = (char *) dest;
  
  /* assegna ad un puntatore a un carattere l'indirizzo della prima
  ** locazione alla variabile sorgente */
  char * byte_sorg = (char *) sorg;
   
  /* scandisce le locazioni assegnate alla variabile sorgente */ 
  for (cursore = 0 ; cursore < sizeof(int); cursore++)
	  /* copia il contenuto della locazione corrente della variabile
      ** sorgente nella corrispondente locazione della variabile
	  ** destinazione */
	  *(byte_dest + cursore) = *(byte_sorg + cursore);
  } 
  
/*
** seconda definizione di una funzione che copia
** una variabile intera sorgente su una variabile intera
** destinazione byte per byte
*/ 
 void CopiaIntBytePerByte_v2 ( int *sorg, int *dest)
  {
  /* definizione della variabile per la scansione
  ** delle locazioni assegnate alle variabili sorgente
  ** e destinazione */
  int cursore;
  
  /* assegna ad un puntatore a un carattere (minima unita' di
  ** informazione indirizzabile) l'indirizzo della prima locazione
  ** assegnata alla variabile destinazione */
  char * byte_dest = (char *) dest;
  
  /* assegna ad un puntatore a un carattere l'indirizzo
  ** della prima locazione assegnata alla variabile sorgente */
  char * byte_sorg = (char *) sorg;
   
  /* scandisce le locazioni allocate alla variabile destinazione */
  for (cursore = 0 ; cursore < sizeof(int); cursore++)
	  /* copia il contenuto della locazione corrente della variabile
      ** sorgente nella corrispondente locazione della variabile
	  ** destinazione */
	  byte_dest[cursore] = byte_sorg[cursore];
  }
  
/* Test delle due versioni della funzione */

int main ()
  {
  /* definizioni delle variabili sorgente e destinazione */
  int source, target;
  
  /* acquisizione della variabile sorgente */
  printf("\nSorgente? ");
  scanf("%d", &source);
  
  /* acquisizione della variabile destinazione */
  printf("\nDestinazione? ");
  scanf("%d", &target);
  
  /* restituzione del valore della destinazione e
  ** della sorgente prima dell'operazione */
  printf("\nPrima Sorgente: %d, Destinazione: %d", source, target);
  
  /* copia la sorgente sulla destinazione byte per byte
  ** utilizzando la prima versione della funzione*/
  CopiaIntBytePerByte_v1 (&source, &target);
  
  /* restituzione del valore della sorgente e
  ** della destinazione dopo l'operazione */
  printf("\nV1 Dopo Sorgente: %d, Destinazione: %d", source, target);
  
  /* acquisizione della variabile destinazione */
  printf("\nNuova destinazione? ");
  scanf("%d", &target);
  
  /* copia la sorgente sulla destinazione byte per byte
  ** utilizzando la prima versione della seconda funzione */
  CopiaIntBytePerByte_v2 (&source, &target);
  
  /* restituzione del valore della sorgente e
  ** della destinazione dopo l'operazione */
  printf("\nV2 Dopo Sorgente: %d, Destinazione: %d", source, target);
  
  return(0);
  }
